package org.vraptor.config;

import org.apache.log4j.Logger;
import org.vraptor.factory.InvalidFactoryException;
import org.vraptor.webapp.WebApplication;

/**
 * Models the xml portion to deal with factory classes
 * 
 * @author Guilherme Silveira
 */
public class FactoryConfig implements ConfigItem {

	private static final Logger LOG = Logger.getLogger(FactoryConfig.class);

	private String typeName;

	public FactoryConfig(String type) {
		super();
		this.typeName = type;
	}

	public String getFactoryClass() {
		return typeName;
	}

	public void register(WebApplication application) throws ConfigException {
		LOG.warn("Factories are deprecated. Use interceptors with @Out");
		try {
			Class type = Class.forName(typeName);
			application.getFactoryManager().register(type);
		} catch (InvalidFactoryException e) {
			throw new ConfigException(e);
		} catch (ClassNotFoundException e) {
			LOG.error("Factory type not found", e);
		}
	}

	public boolean isComponent() {
		return true;
	}

	public boolean isManager() {
		return false;
	}
}
