package org.vraptor.factory;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * A factory method.
 *
 * @author Guilherme Silveira
 */
public class FactoryMethod {

	private String key;

	private Method method;

	/**
	 * Simple constructor with annotation and method
	 *
	 * @param annotation
	 *            the annotation
	 * @param method
	 *            the method
	 */
	public FactoryMethod(String key, Method method) {
		super();
		this.key = key;
		this.method = method;
	}

	/**
	 * Returns the new instance
	 *
	 * @return the new instance
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws IllegalArgumentException
	 */
	public Object execute(Object component) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		return this.method.invoke(component);
	}

	/**
	 * @return Returns the key.
	 */
	public String getKey() {
		return this.key;
	}

}
