package org.vraptor.plugin;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;

import org.apache.log4j.Logger;
import org.vraptor.LogicRequest;
import org.vraptor.core.WebRequest;
import org.vraptor.scope.DefaultLogicRequest;
import org.vraptor.scope.RequestContext;
import org.vraptor.view.ViewException;
import org.vraptor.view.ViewManager;

@Deprecated
public class HtmlProxyTestViewManager implements ViewManager {

	private static final Logger LOG = Logger.getLogger(HtmlProxyTestViewManager.class);

	private final ViewManager manager;

	public HtmlProxyTestViewManager(ViewManager viewManager) {
		LOG.debug("Creating html proxy view manager");
		this.manager = viewManager;
	}

	public void forward(LogicRequest request, String result) throws ViewException {
		ByteArrayOutputStream stream = new ByteArrayOutputStream();
		request = wrapLogicRequest(request, wrapResponse(request.getResponse(), stream));
		manager.forward(request, result);
		writeResult(request.getRequestContext(), request.getResponse(), stream.toByteArray());
	}

	private HttpServletResponse wrapResponse(HttpServletResponse response, final OutputStream stream) {
		final ServletOutputStream sos = new ServletOutputStream() {
			@Override
			public void write(int b) throws IOException {
				stream.write(b);
			}
		};
		final PrintWriter writer = new PrintWriter(sos, true);
		return new HttpServletResponseWrapper(response) {
			@Override
			public PrintWriter getWriter() throws IOException {
				return writer;
			}

			@Override
			public ServletOutputStream getOutputStream() throws IOException {
				return sos;
			}
		};
	}

	private void writeResult(RequestContext request, HttpServletResponse response, byte[] bs) throws ViewException {
		String result = (String) request.getAttribute(HtmlTestCreator.CREATOR_ID);
		try {
			OutputStream os = response.getOutputStream();
			PrintWriter writer = new PrintWriter(os, true);
			writer.println(result);
			writer.println("<!-- original result-->");
			os.write(bs);
		} catch (IOException e) {
			throw new ViewException("Unable to output html proxy test.");
		}
	}

	public void directForward(LogicRequest request, String result, String forwardUrl) throws ViewException {
		ByteArrayOutputStream stream = new ByteArrayOutputStream();
		request = wrapLogicRequest(request, wrapResponse(request.getResponse(), stream));
		manager.directForward(request, result, forwardUrl);
		writeResult(request.getRequestContext(), request.getResponse(), stream.toByteArray());
	}

	public void redirect(LogicRequest request, String result) throws ViewException {
		ByteArrayOutputStream stream = new ByteArrayOutputStream();
		request = wrapLogicRequest(request, wrapResponse(request.getResponse(), stream));
		manager.redirect(request, result);
		writeResult(request.getRequestContext(), request.getResponse(), stream.toByteArray());
	}

	private LogicRequest wrapLogicRequest(LogicRequest request, HttpServletResponse response) {
		WebRequest webRequest = new WebRequest(request.getRequest(), response, request.getServletContext());
		DefaultLogicRequest newRequest = new DefaultLogicRequest(request.getRequestInfo(), webRequest);
		newRequest.setLogicDefinition(request.getLogicDefinition());
		newRequest.confirmResult(request.getResult());
		return newRequest;
	}

}
