package org.vraptor.plugin;

import org.vraptor.LogicException;
import org.vraptor.LogicRequest;
import org.vraptor.component.LogicMethod;

/**
 * A test based proxy implementation.
 */
class ProxyTestLogicMethod extends LogicMethodWrapper {

	private final HtmlTestCreator creator;

	public ProxyTestLogicMethod(LogicMethod logic, HtmlTestCreator creator) {
		super(logic);
		this.creator = creator;
	}

	public String execute(Object component, LogicRequest request) throws LogicException {
		String result = super.execute(component, request, new Object[0]);
		if (result == null) {
			result = "ok";
		}
		creator.execute(component, request, result);
		return result;
	}

	public boolean shouldRedirect() {
		return creator.shouldRedirect() && super.shouldRedirect();
	}

}
