package org.vraptor.plugin;

import org.vraptor.component.LogicNotFoundException;
import org.vraptor.webapp.WebApplication;

/**
 * A plugin capable of creating functional testing classes.
 *
 * @author Guilherme Silveira
 */
public class ProxyTestPlugin implements VRaptorPlugin {

	private final HtmlTestCreator creator = new HtmlTestCreator();

	public void init(WebApplication application) throws LogicNotFoundException {
		ComponentWrapperVisitor visitor = new ComponentWrapperVisitor(creator);
		visitor.visit(application.getComponentManager());
	}

}
